<template>
  <no-ssr>
    <div class="chat-no-login">
      <button
        @click="isVisible = true"
        class="mainbtn"
        v-tooltip.ios="chatTooltip">
        ЧАТ
        <img
          svg-inline
          src="~/assets/svg/chat-man.svg">
      </button>

      <div
        v-if="isVisible"
        class="begin-form">
        <div class="content">
          <i
            class="btn-close"
            @click="isVisible = false">
            <img
              svg-inline
              src="~/assets/svg/icons/i-close-chat.svg">
          </i>
          <form
            class="ui form"
            novalidate
            :class="{ loading }"
            @submit.prevent="send">
            <div class="title">Чат с технической поддержкой или автоконсьержем</div>

            <div
              class="field"
              :class="{ invalid: validation.hasError('name') }">
              <label>Как к вам обращаться <span class="red">*</span>
              </label>
              <div class="ui input">
                <input
                  type="text"
                  v-model="name"
                  placeholder="Имя">
              </div>
              <div
                v-if="validation.hasError('name')"
                class="message error">
                {{ validation.firstError('name') }}
              </div>
            </div>

            <div
              class="field"
              :class="{invalid: validation.hasError('email')}">
              <label>Укажите адрес электронной почты</label>
              <div class="ui input">
                <input
                  type="text"
                  v-model="email"
                  placeholder="E-mail">
              </div>
              <div
                v-if="issetErrors.email || validation.hasError('email')"
                class="message error">
                {{ issetErrors.email || validation.firstError('email') }}
                <span v-if="issetErrors.email">
                  <br>
                  <a
                    href="#"
                    @click.prevent="isVisible = false; showAuthModal();">Авторизуйтесь</a>
                  или укажите другой e-mail.
                </span>
              </div>
            </div>

            <div class="field">
              <label>Укажите ваш телефон, для получения оперативного ответа</label>
              <AppInputPhone
                v-model="phone"
                @has-error="inputErrors.phone = $event"/>
              <div
                v-if="issetErrors.phone"
                class="message error">
                {{ issetErrors.phone }}
                <span v-if="issetErrors.phone">
                  <br>
                  <a
                    href="#"
                    @click.prevent="isVisible = false; showAuthModal();">Авторизуйтесь</a>
                  или укажите другой номер телефона.
                </span>
              </div>
            </div>
            <div class="text-agreement">
              Нажимая на кнопку &laquo;Войти в чат&raquo; вы даете согласие на
              <flink
                target="_blank"
                domain="main"
                href="/about-us/agreement"
                class="kit aqualink">обработку персональных данных
              </flink>
            </div>

            <div
              v-if="apiError"
              class="error-message">
              Временная ошибка, пожалуйста, повторите запрос позднее
            </div>

            <button
              type="submit"
              :disabled="submitDisabled"
              class="button-chat">
              Войти в чат
            </button>
          </form>
        </div>
      </div>
    </div>
  </no-ssr>
</template>

<script>
import BeginChatMixin from '~/assets/js/mixins/begin-chat';

import AppInputPhone from '~/components/redesign/app-input/app-input-phone';

export default {
  name: 'ChatNoLogin',
  components: {
    AppInputPhone,
  },
  mixins: [BeginChatMixin],
  data() {
    return {
      isVisibleForm: false,
      chatTooltip: {
        classes: 'ui popup tooltip visible dark bottom',
        placement: 'left-end',
        trigger: 'hover',
        offset: '4',
        html: 'true',
        content: `<div style='text-align: center'>
                         Если Вы хотите получить бесплатную консультацию по подбору запчасти –
                         задайте их Автоконсьержу или сообщите о проблемах Технической Поддержке
                            </div>`,
      },
    };
  },
  computed: {
    isVisible: {
      get() {
        return this.isVisibleForm;
      },
      set(newVal) {
        if (newVal) {
          this.show();
        } else {
          this.hide();
        }
      },
    },
  },
  methods: {
    show() {
      this.isVisibleForm = true;
    },
    hide() {
      this.isVisibleForm = false;
    },
  },
};
</script>

<style scoped lang="scss">
  .chat-no-login {
    .mainbtn {
      cursor: pointer;
      position: fixed;
      bottom: 0.5rem;
      right: 1rem;
      z-index: 999;
      display: flex;
      justify-content: center;
      align-items: center;
      min-width: 4.875rem;
      width: auto;
      height: 2.25rem;
      background-color: #fff;
      color: #8798a4;
      font-family: Roboto, sans-serif;
      font-size: 0.75rem;
      line-height: 1.2;
      font-weight: normal;
      text-transform: none;
      font-style: normal;
      box-shadow: rgba(100, 115, 132, 0.16) -1px 4px 14px;
      outline: none;
      flex-flow: row nowrap;
      padding: 0 0.75rem;
      border-radius: 1.125rem;
      border: 1px solid #e4ebf6;
      .svg {
        display: block;
        margin-left: 0.25rem;
        width: 0.75rem;
        height: auto;
        fill: #C5D1D9;
        stroke: #C5D1D9;
        transition: fill 0.1s ease, stroke 0.1s ease;
      }
      &:hover {
        .svg {
          fill: #8798a4;
          stroke: #8798a4;
        }
      }
    }

    .begin-form {
      position: fixed;
      bottom: 0.5rem;
      right: 1rem;
      z-index: 1000;

      > .content {
        position: relative;
        display: block;
        background-color: #ffffff;
        border: 1px solid rgba(39, 39, 39, 0.6);
        border-radius: 0;
      }

      @media only screen and (max-width: 1024px) {
        display: flex;
        bottom: 0;
        right: 0;
        height: 100vh;
        width: 100vw;
        > .content {
          margin-top: auto;
          padding: 2rem 1rem 2rem;
          width: 100vw;
          max-width: 30rem;
        }
      }
      @media only screen and (min-width: 1025px) {
        > .content {
          padding: 3rem 2rem 2rem;
          width: 23rem;
        }
      }

      .btn-close {
        position: absolute;
        z-index: 1;
        top: 0.5rem;
        right: 0.5rem;
        display: block;
        width: auto;
        height: auto;
        padding: 0.5625rem;
        cursor: pointer;

        svg {
          width: 0.625rem;
          height: auto;
          stroke: #8798a4;
          transition: stroke 0.2s ease;
        }

        &:hover {
          svg {
            stroke: #4272a4;
          }
        }

        @media only screen and (max-width: 1024px) {
          padding: 0.875rem;
          svg {
            width: 0.875rem;
          }
        }
      }

      .ui.form {
        width: 100%;

        .red {
          color: #E13C3C;
        }

        .title {
          display: block;
          width: 100%;
          font-size: 0.875rem;
          font-weight: 700;
          line-height: 1.3;
          padding: 0 0 1rem;
          @media only screen and (max-width: 1024px) {
            font-size: 1.125rem;
            padding-top: 2rem;
          }
        }

        .error-message,
        .text-agreement {
          padding: 1rem 0 0 1rem;
          font-size: 0.6875rem;
          line-height: 1.3;
          font-weight: 400;
          @media only screen and (max-width: 1024px) {
            font-size: 0.8125rem;
          }
        }

        .kit.aqualink {
          display: inline;
        }

        .error-message {
          display: block;
          color: #E13C3C;
        }

        .button-chat {
          display: block;
          text-align: center;
          cursor: pointer;
          outline: none;
          box-shadow: none;
          min-width: 8rem;
          padding: 0.5rem 0.75rem;
          margin: 1rem auto 0;
          font-size: 0.8125rem;
          border-radius: 2rem;
          color: #fff;
          background-color: #3779cf;
          border: 1px solid #3779cf;
          transition: background-color 0.2s ease;

          &:hover:not(:disabled) {
            background-color: #2665b7;
          }

          &:disabled {
            opacity: .65;
            cursor: default;
          }

          @media only screen and (max-width: 1024px) {
            min-width: 13.125rem;
            margin-bottom: 1rem;
            padding: 0.75rem;
            font-size: 1rem;
          }
        }
      }
    }
  }

</style>
